#!/usr/bin/env python
# encoding: utf-8
"""
seinforge2smil.py

Created by Brendan Erwin on 2008-05-23.
Copyright (c) 2008 Brendan Erwin. All rights reserved.

CAUTION: VERY HACKY. This relies on a great many "side effects" observed in the Skeinforge output. It WILL break.

Transforms the G Code output from Skeinforge into SMIL (Sliced Model Intermediate Language) for later processing into
machine/material G Code.
"""

import sys
import os
import HackedgRead


def main():
	layers = []
	g = gRead.gRead("Screw Holder_fillet.gcode", layers)
	print '<SSIL LayerCount="' + str(len(layers)) + '" >'
	layerCount = 0
	for l in layers:
		print '\t<LAYER Sequence="' + str(layerCount) + '" >'
		print '\t\t<TOOL Name="PolymerExtruder" Sequence="0">'
		threadCount = 0
		for thread in l:
			if len(thread) > 1:
				#Create new thread XML object here
				print '\t\t\t<THREAD Sequence="' + str(threadCount) + '">'
				pointCount = 0
				for point in thread:
					if not (layerCount < 2 and point.z > 5):
						print '\t\t\t\t<POINT X="' + str(point.x) + '" Y="' + str(point.y) + '" Sequence="' + str(pointCount) + '" />'
						pointCount += 1
				print "\t\t\t</THREAD>"
				threadCount += 1
		print '\t\t</TOOL>'
		print '\t</LAYER>'
		layerCount += 1
	print "</SSIL>"

if __name__ == '__main__':
	main()

